diff --git isisd/isis_vlans.h isisd/isis_vlans.h
new file mode 100644
index 0000000..9a54e58
--- /dev/null
+++ isisd/isis_vlans.h
@@ -0,0 +1,128 @@
+/*
+ * IS-IS Rout(e)ing protocol - isis_vlans.h
+ *
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of the GNU General Public Licenseas published by the Free 
+ * Software Foundation; either version 2 of the License, or (at your option) 
+ * any later version.
+ *
+ * This program is distributed in the hope that it will be useful,but WITHOUT 
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for 
+ * more details.
+
+ * You should have received a copy of the GNU General Public License along 
+ * with this program; if not, write to the Free Software Foundation, Inc., 
+ * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+ */
+#ifndef  ISIS_VLANS_H
+#define	ISIS_VLANS_H
+
+/* TRILL IS-IS VLANs */
+#define NO_TCI 0
+#define DFLT_VLAN 1
+#define VLANS_SIZE (1<<12)
+#define VLANS_ARRSIZE (VLANS_SIZE/NBBY)
+#define VLAN_MAX 4094
+#define VLAN_MIN 1
+#define VLANTCI(p) ((p)&((VLANS_SIZE)-1))
+
+#define VLANBIT(v) ((v) % NBBY)
+#define VLANBYTE(v) ((v)/NBBY)
+#define CHECK_VLAN(p, v) ((p)[VLANBYTE(v)] & (1<<VLANBIT(v)))
+#define SET_VLAN(p, v) \
+       	do { \
+          if ((v) > 0) \
+       	    ((p)[VLANBYTE(v)] |= 1<<VLANBIT(v)); \
+	} while (0)
+#define CLEAR_VLAN(p, v) \
+	do { \
+          if ((v) > 0) \
+	    ((p)[VLANBYTE(v)] &= ~(1<<VLANBIT(v))); \
+	} while (0)
+
+#define EACH_VLAN(p, v, c) \
+	for ( \
+	(v) = VLAN_MIN; \
+        ((v) <= VLAN_MAX) && \
+	((c) = CHECK_VLAN((p), (v)), 1); \
+	(v)++ )
+
+#define EACH_VLAN_SET(p, v, c) \
+	EACH_VLAN(p, v, c) \
+        if (c) \
+
+#define EACH_VLAN_R(p, v, c) \
+	for (; \
+        ((v) <= VLAN_MAX) && \
+	((c) = CHECK_VLAN((p), (v)), 1); \
+	(v)++ ) \
+
+#define EACH_VLAN_SET_R(p, v, c) \
+	EACH_VLAN_R(p, v, c) \
+	if (c) \
+
+#define MERGE_VLANS(p, v, z) \
+	do { \
+	  for ((v) = 0; (v) < VLANS_ARRSIZE; (v)++) \
+	   (p)[(v)] |= (z)[(v)]; \
+	} while (0)
+
+/* source: http://graphics.stanford.edu/~seander/bithacks.html */
+#define REVERSE_BYTE(v) ((uint8_t)((((v) * 0x0802LU & 0x22110LU) | \
+       	((v) * 0x8020LU & 0x88440LU)) * 0x10101LU >> 16));
+
+#define MAX_VLANS_SUBTLV_LEN 240 /* 255 - bytes for type, len, start vlan */
+
+/* Encoded enabled VLANs information for Hello PDU PCTLV_ENABLEDVLANS */
+struct trill_enabled_vlans_listnode
+{
+  uint16_t len;
+  struct trill_enabledvlans_subtlv tlvdata;
+};
+
+/*
+ * Entry on the inhibit_vlan list.  This should be rarely used; it corresponds
+ * to receipt of a Hello message from some other node claiming AF status for a
+ * VLAN for which we were appointed.
+ */
+struct trill_inhibit_vlan
+{
+  time_t reenable;
+  u_int16_t vlan;
+};
+
+struct trill_circuit_vlans
+{
+  u_int16_t pvid;	 /* Default/Native VLAN for untagged frames */
+  u_int16_t designated;	 /* Designated VLAN for the circuit */
+  u_int16_t our_designated; /* Our choice for Designated VLAN */
+  u_int8_t enabled[VLANS_ARRSIZE]; /* VLANs we could be the forwarder */
+  u_int8_t forwarder[VLANS_ARRSIZE]; /* VLANs for which we are the forwarder */
+  u_int16_t rx_tci; /* PCP, CFI, VID */
+  u_int16_t tx_tci; /* PCP, CFI, VID */
+  struct list *enabled_vlans; /* List of enabled vlans TLV data */
+  struct list *appvlanfwders; /* Appointed VLAN forwarders */
+  u_int32_t vlanfwdershash;   /* Hash to check change in VLAN forwarders */
+  struct list *inhibit_vlans;	/* VLANs inhibited by foreign AF flags (rare) */
+  time_t inhibit_all;		/* All inhibited by root bridge (common) */
+  struct thread *inhibit_thread;
+};
+
+struct trill_adj_vlans
+{
+  u_int16_t designated;   /* Designated VLAN when adj is DR */
+  u_int8_t forwarder[VLANS_ARRSIZE];  /* VLANs the adj forwards */
+  u_int8_t enabled[VLANS_ARRSIZE]; /* VLANs the adj has enabled */
+  u_int8_t seen[VLANS_ARRSIZE]; /* VLANs we send hellos to adj */
+};
+
+struct trill_vlan_bridge_roots
+{
+    int vlan_start;
+    int vlan_end;
+    int bridge_roots_count;
+    struct ether_addr *bridge_roots;
+};
+
+#endif /* ISIS_VLANS_H */
diff --git isisd/isisd.c isisd/isisd.c
index 7c669fc..3ea6fcd 100644
--- isisd/isisd.c
+++ isisd/isisd.c
@@ -40,7 +40,6 @@
 #include "isisd/isis_common.h"
 #include "isisd/isis_circuit.h"
 #include "isisd/isis_flags.h"
-#include "isisd/isisd.h"
 #include "isisd/isis_dynhn.h"
 #include "isisd/isis_adjacency.h"
 #include "isisd/isis_pdu.h"
@@ -52,6 +51,12 @@
 #include "isisd/isis_route.h"
 #include "isisd/isis_zebra.h"
 #include "isisd/isis_events.h"
+#ifdef HAVE_TRILL
+#include "isisd/isis_vlans.h"
+#include "isisd/isis_trill.h"
+#endif
+#include "isisd/isisd.h"
+#include "isisd/bool.h"
 
 #ifdef TOPOLOGY_GENERATE
 #include "spgrid.h"
@@ -64,14 +69,11 @@ extern struct thread_master *master;
 /*
  * Prototypes.
  */
-void isis_new(unsigned long);
-struct isis_area *isis_area_create(void);
 int isis_area_get(struct vty *, const char *);
 int isis_area_destroy(struct vty *, const char *);
-int area_net_title(struct vty *, const u_char *);
-int area_clear_net_title(struct vty *, const u_char *);
+int area_net_title(struct vty *, const char *);
+int area_clear_net_title(struct vty *, const char *);
 int show_clns_neigh(struct vty *, char);
-void print_debug(struct vty *, int, int);
 int isis_config_write(struct vty *);
 
 
@@ -100,7 +102,7 @@ isis_new (unsigned long process_id)
 }
 
 struct isis_area *
-isis_area_create ()
+isis_area_create (const char *area_tag)
 {
   struct isis_area *area;
 
@@ -131,6 +133,9 @@ isis_area_create ()
   area->area_addrs = list_new ();
   THREAD_TIMER_ON (master, area->t_tick, lsp_tick, area, 1);
   flags_initialize (&area->flags);
+#ifdef HAVE_TRILL
+  area->trill = XCALLOC (MTYPE_ISIS_TRILLAREA, sizeof (struct trill_info));
+#endif
   /*
    * Default values
    */
@@ -152,6 +157,15 @@ isis_area_create ()
   /* FIXME: Think of a better way... */
   area->min_bcast_mtu = 1497;
 
+  area->area_tag = strdup (area_tag);
+  listnode_add (isis->area_list, area);
+  area->isis = isis;
+
+#ifdef HAVE_TRILL
+  if (isis->trill_active)
+    trill_area_init (area);
+#endif
+
   return area;
 }
 
@@ -184,9 +198,17 @@ isis_area_get (struct vty *vty, const char *area_tag)
       return CMD_SUCCESS;
     }
 
-  area = isis_area_create ();
-  area->area_tag = strdup (area_tag);
-  listnode_add (isis->area_list, area);
+#ifdef HAVE_TRILL
+  if (isis->trill_active && isis->area_list->count != 0)
+    { 
+      vty_out (vty,
+	"TRILL area exists, can only define one IS-IS area for TRILL. %s",
+	VTY_NEWLINE);
+      return CMD_WARNING;
+    }
+#endif
+
+  area = isis_area_create (area_tag);
 
   if (isis->debugs & DEBUG_EVENTS)
     zlog_debug ("New IS-IS area instance %s", area->area_tag);
@@ -212,6 +234,12 @@ isis_area_destroy (struct vty *vty, const char *area_tag)
       return CMD_WARNING;
     }
 
+#ifdef HAVE_TRILL
+  trill_area_free (area);
+  XFREE (MTYPE_ISIS_TRILLAREA, area->trill);
+#endif
+  spftree_area_del (area);
+
   if (area->circuit_list)
     {
       for (ALL_LIST_ELEMENTS (area->circuit_list, node, nnode, circuit))
@@ -230,13 +258,14 @@ isis_area_destroy (struct vty *vty, const char *area_tag)
   THREAD_TIMER_OFF (area->t_lsp_refresh[0]);
   THREAD_TIMER_OFF (area->t_lsp_refresh[1]);
 
+  free (area->area_tag);
   XFREE (MTYPE_ISIS_AREA, area);
 
   return CMD_SUCCESS;
 }
 
 int
-area_net_title (struct vty *vty, const u_char *net_title)
+area_net_title (struct vty *vty, const char *net_title)
 {
   struct isis_area *area;
   struct area_addr *addr;
@@ -330,7 +359,7 @@ area_net_title (struct vty *vty, const u_char *net_title)
 }
 
 int
-area_clear_net_title (struct vty *vty, const u_char *net_title)
+area_clear_net_title (struct vty *vty, const char *net_title)
 {
   struct isis_area *area;
   struct area_addr addr, *addrp = NULL;
@@ -524,7 +553,10 @@ print_debug (struct vty *vty, int flags, int onoff)
 	     VTY_NEWLINE);
   if (flags & DEBUG_EVENTS)
     vty_out (vty, "IS-IS Event debugging is %s%s", onoffs, VTY_NEWLINE);
-
+#ifdef HAVE_TRILL
+  if (flags & DEBUG_TRILL_EVENTS)
+    vty_out (vty, "IS-IS TRILL Event debugging is %s%s", onoffs, VTY_NEWLINE);
+#endif
 }
 
 DEFUN (show_debugging,
@@ -606,6 +638,13 @@ config_write_debug (struct vty *vty)
       vty_out (vty, "debug isis events%s", VTY_NEWLINE);
       write++;
     }
+#ifdef HAVE_TRILL
+  if (flags & DEBUG_TRILL_EVENTS)
+    {
+      vty_out (vty, "debug trill events%s", VTY_NEWLINE);
+      write++;
+    }
+#endif
 
   return write;
 }
@@ -792,7 +831,6 @@ DEFUN (no_debug_isis_spfevents,
   return CMD_SUCCESS;
 }
 
-
 DEFUN (debug_isis_spfstats,
        debug_isis_spfstats_cmd,
        "debug isis spf-statistics ",
@@ -1045,7 +1083,7 @@ DEFUN (area_passwd,
 
   if (!area)
     {
-      vty_out (vty, "Cant find IS-IS instance%s", VTY_NEWLINE);
+      vty_out (vty, "Can't find IS-IS instance%s", VTY_NEWLINE);
       return CMD_WARNING;
     }
 
@@ -1098,7 +1136,7 @@ DEFUN (no_area_passwd,
 
   if (!area)
     {
-      vty_out (vty, "Cant find IS-IS instance%s", VTY_NEWLINE);
+      vty_out (vty, "Can't find IS-IS instance%s", VTY_NEWLINE);
       return CMD_WARNING;
     }
 
@@ -1120,7 +1158,7 @@ DEFUN (domain_passwd,
 
   if (!area)
     {
-      vty_out (vty, "Cant find IS-IS instance%s", VTY_NEWLINE);
+      vty_out (vty, "Can't find IS-IS instance%s", VTY_NEWLINE);
       return CMD_WARNING;
     }
 
@@ -1173,7 +1211,7 @@ DEFUN (no_domain_passwd,
 
   if (!area)
     {
-      vty_out (vty, "Cant find IS-IS instance%s", VTY_NEWLINE);
+      vty_out (vty, "Can't find IS-IS instance%s", VTY_NEWLINE);
       return CMD_WARNING;
     }
 
@@ -1197,7 +1235,7 @@ DEFUN (is_type,
 
   if (!area)
     {
-      vty_out (vty, "Cant find IS-IS instance%s", VTY_NEWLINE);
+      vty_out (vty, "Can't find IS-IS instance%s", VTY_NEWLINE);
       return CMD_WARNING;
     }
 
@@ -1207,6 +1245,14 @@ DEFUN (is_type,
       vty_out (vty, "Unknown IS level %s", VTY_NEWLINE);
       return CMD_SUCCESS;
     }
+ 
+#ifdef HAVE_TRILL
+  if (area->isis->trill_active)
+    {
+      vty_out (vty, "Can't set level when TRILL is enabled%s", VTY_NEWLINE);
+      return CMD_WARNING;
+    }
+#endif
 
   isis_event_system_type_change (area, type);
 
@@ -1228,6 +1274,14 @@ DEFUN (no_is_type,
   area = vty->index;
   assert (area);
 
+#ifdef HAVE_TRILL
+  if (area->isis->trill_active)
+    {
+      vty_out (vty, "Can't reset level when TRILL is enabled%s", VTY_NEWLINE);
+      return CMD_WARNING;
+    }
+#endif
+
   /*
    * Put the is-type back to default. Which is level-1-2 on first
    * circuit for the area level-1 for the rest
@@ -1894,6 +1948,15 @@ isis_config_write (struct vty *vty)
       struct isis_area *area;
       struct listnode *node, *node2;
 
+#ifdef HAVE_TRILL
+      /* ISIS - TRILL enabled control flag */
+      if (isis->trill_active)
+        {
+          vty_out (vty, "isis trill%s", VTY_NEWLINE);
+          write++;
+	}
+#endif
+
       for (ALL_LIST_ELEMENTS_RO (isis->area_list, node, area))
       {
 	/* ISIS - Area name */
@@ -1943,6 +2006,31 @@ isis_config_write (struct vty *vty)
 		write++;
 	      }
 	  }
+
+#ifdef HAVE_TRILL
+	/* ISIS TRILL configuration options */
+	if (isis->trill_active)
+          {
+	     if (CHECK_FLAG(area->trill->status, TRILL_NICK_SET) &&
+	          (!CHECK_FLAG(area->trill->status, TRILL_AUTONICK)))
+               {
+                 vty_out (vty, " trill nickname %d%s", area->trill->nick.name,
+				 VTY_NEWLINE);
+                 write++;
+               }
+	     if (CHECK_FLAG(area->trill->status, TRILL_PRIORITY_SET))
+               {
+                 vty_out (vty, " trill nickname priority %d%s",
+			 (area->trill->nick.priority & (~CONFIGURED_NICK_PRIORITY)),
+			 VTY_NEWLINE);
+                 write++;
+               }
+
+	     vty_out(vty, " trill instance %s%s", area->trill->name, VTY_NEWLINE);
+	     write++;
+	  }
+#endif
+
 	/* ISIS - Lsp generation interval */
 	if (area->lsp_gen_interval[0] == area->lsp_gen_interval[1])
 	  {
@@ -2053,7 +2141,7 @@ isis_config_write (struct vty *vty)
 		    ISIS_SYS_ID_LEN))
 	  {
 	    vty_out (vty, " topology base-is %s%s",
-		     sysid_print (area->topology_baseis), VTY_NEWLINE);
+		     sysid_print ((u_char *)area->topology_baseis), VTY_NEWLINE);
 	    write++;
 	  }
 	if (area->topology_basedynh)
@@ -2218,9 +2306,4 @@ isis_init ()
   install_element (VIEW_NODE, &show_isis_generated_topology_cmd);
   install_element (ENABLE_NODE, &show_isis_generated_topology_cmd);
 #endif /* TOPOLOGY_GENERATE */
-
-  isis_new (0);
-  isis_circuit_init ();
-  isis_zebra_init ();
-  isis_spf_cmds_init ();
 }
diff --git isisd/isisd.h isisd/isisd.h
index 2277f27..945d423 100644
--- isisd/isisd.h
+++ isisd/isisd.h
@@ -51,6 +51,9 @@ struct isis
   u_int32_t debugs;		/* bitmap for debug */
   time_t uptime;		/* when did we start */
   struct thread *t_dync_clean;	/* dynamic hostname cache cleanup thread */
+#ifdef HAVE_TRILL
+  int trill_active;		/* TRILL support is active */
+#endif
 
   /* Redistributed external information. */
   struct route_table *external_info[ZEBRA_ROUTE_MAX + 1];
@@ -78,6 +81,8 @@ struct isis
 #endif
 };
 
+extern struct isis *isis;
+
 struct isis_area
 {
   struct isis *isis;				  /* back pointer */
@@ -95,6 +100,9 @@ struct isis_area
   struct thread *t_remove_aged;
   int lsp_regenerate_pending[ISIS_LEVELS];
   struct thread *t_lsp_refresh[ISIS_LEVELS];
+#ifdef HAVE_TRILL
+  struct trill_info *trill;     /* TRILL IS-IS information */
+#endif
 
   /*
    * Configurables 
@@ -128,14 +136,20 @@ struct isis_area
 
 #ifdef TOPOLOGY_GENERATE
   struct list *topology;
-  char topology_baseis[ISIS_SYS_ID_LEN];  /* IS for the first IS emulated. */
+  u_char topology_baseis[ISIS_SYS_ID_LEN];  /* IS for the first IS emulated. */
   char *topology_basedynh;                /* Dynamic hostname base. */
   char top_params[200];                   /* FIXME: what is reasonable? */
 #endif /* TOPOLOGY_GENERATE */
 };
 
 void isis_init (void);
+void isis_new(unsigned long);
+struct isis_area *isis_area_create(const char *);
 struct isis_area *isis_area_lookup (const char *);
+void print_debug(struct vty *, int, int);
+
+/* Master of threads. */
+extern struct thread_master *master;
 
 #define DEBUG_ADJ_PACKETS                (1<<0)
 #define DEBUG_CHECKSUM_ERRORS            (1<<1)
@@ -149,5 +163,8 @@ struct isis_area *isis_area_lookup (const char *);
 #define DEBUG_RTE_EVENTS                 (1<<9)
 #define DEBUG_EVENTS                     (1<<10)
 #define DEBUG_ZEBRA                      (1<<11)
+#ifdef HAVE_TRILL
+#define DEBUG_TRILL_EVENTS		 (1<<12)
+#endif
 
 #endif /* ISISD_H */
diff --git lib/command.h lib/command.h
index a725378..fefa6d3 100644
--- lib/command.h
+++ lib/command.h
@@ -303,6 +303,8 @@
 #define OSPF6_DUMP_TYPE_LIST \
 "(neighbor|interface|area|lsa|zebra|config|dbex|spf|route|lsdb|redistribute|hook|asbr|prefix|abr)"
 #define ISIS_STR "IS-IS information\n"
+#define TRILL_STR "TRILL IS-IS information\n"
+#define TRILL_NICK_STR "Configure TRILL RBridge nickname information\n"
 #define AREA_TAG_STR "[area tag]\n"
 
 #define CONF_BACKUP_EXT ".sav"
diff --git lib/memtypes.c lib/memtypes.c
index c7028c9..476ad35 100644
--- lib/memtypes.c
+++ lib/memtypes.c
@@ -228,20 +228,32 @@
 
 struct memory_list memory_list_isis[] =
 {
-  { MTYPE_ISIS,               "ISIS"				},
-  { MTYPE_ISIS_TMP,           "ISIS TMP"			},
-  { MTYPE_ISIS_CIRCUIT,       "ISIS circuit"			},
-  { MTYPE_ISIS_LSP,           "ISIS LSP"			},
-  { MTYPE_ISIS_ADJACENCY,     "ISIS adjacency"			},
-  { MTYPE_ISIS_AREA,          "ISIS area"			},
-  { MTYPE_ISIS_AREA_ADDR,     "ISIS area address"		},
-  { MTYPE_ISIS_TLV,           "ISIS TLV"			},
-  { MTYPE_ISIS_DYNHN,         "ISIS dyn hostname"		},
-  { MTYPE_ISIS_SPFTREE,       "ISIS SPFtree"			},
-  { MTYPE_ISIS_VERTEX,        "ISIS vertex"			},
-  { MTYPE_ISIS_ROUTE_INFO,    "ISIS route info"			},
-  { MTYPE_ISIS_NEXTHOP,       "ISIS nexthop"			},
-  { MTYPE_ISIS_NEXTHOP6,      "ISIS nexthop6"			},
+  { MTYPE_ISIS,                  "ISIS"				},
+  { MTYPE_ISIS_TMP,              "ISIS TMP"			},
+  { MTYPE_ISIS_CIRCUIT,          "ISIS circuit"			},
+  { MTYPE_ISIS_LSP,              "ISIS LSP"			},
+  { MTYPE_ISIS_ADJACENCY,        "ISIS adjacency"		},
+  { MTYPE_ISIS_AREA,             "ISIS area"			},
+  { MTYPE_ISIS_AREA_ADDR,        "ISIS area address"		},
+  { MTYPE_ISIS_TLV,              "ISIS TLV"			},
+  { MTYPE_ISIS_DYNHN,            "ISIS dyn hostname"		},
+  { MTYPE_ISIS_SPFTREE,          "ISIS SPFtree"			},
+  { MTYPE_ISIS_VERTEX,           "ISIS vertex"			},
+  { MTYPE_ISIS_ROUTE_INFO,       "ISIS route info"		},
+  { MTYPE_ISIS_NEXTHOP,          "ISIS nexthop"			},
+  { MTYPE_ISIS_NEXTHOP6,         "ISIS nexthop6"		},
+  { MTYPE_ISIS_TRILLAREA,	 "ISIS TRILL area information"  },
+  { MTYPE_ISIS_TRILL_NICKDB_NODE,"ISIS TRILL nickdb node"   	},
+  { MTYPE_ISIS_TRILL_FWDTBL_NODE,"ISIS TRILL forwarding table node"},
+  { MTYPE_ISIS_TRILL_VLANS,	 "ISIS TRILL vlans"},
+  { MTYPE_ISIS_TRILL_ADJVLANS,	 "ISIS TRILL adjacency vlans"},
+  { MTYPE_ISIS_TRILL_VLANBRIDGE_ROOTS, "ISIS TRILL vlan bridge roots"},
+  { MTYPE_ISIS_TRILL_BRIDGE_ROOTIDS, "ISIS TRILL vlan bridge root IDs"},
+  { MTYPE_ISIS_TRILL_VLANSREACHABLE, "ISIS TRILL vlans reachable downstream"},
+  { MTYPE_ISIS_TRILL_VLANFWDERS, "ISIS TRILL VLAN forwarders" },
+  { MTYPE_ISIS_TRILL_ENABLEDVLANS, "ISIS TRILL enabled VLAN maps" },
+  { MTYPE_ISIS_TRILL_VLANSUBTLV, "ISIS TRILL VLAN subTLV construction" },
+  { MTYPE_ISIS_TRILL_INHIB,	 "ISIS TRILL VLAN inhibit entry" },
   { -1, NULL },
 };
 
diff --git lib/privs.c lib/privs.c
index 69606f5..d290a59 100644
--- lib/privs.c
+++ lib/privs.c
@@ -105,6 +105,7 @@ static struct
   [ZCAP_BIND] =		{ 2, (pvalue_t []) { CAP_NET_BIND_SERVICE,
                                              CAP_NET_BROADCAST 		}, },
   [ZCAP_NET_ADMIN] =	{ 1, (pvalue_t []) { CAP_NET_ADMIN		}, },
+  [ZCAP_DL_CONFIG] =	{ 1, (pvalue_t []) { CAP_NET_ADMIN		}, },
   [ZCAP_NET_RAW] = 	{ 1, (pvalue_t []) { CAP_NET_RAW		}, },
   [ZCAP_CHROOT] = 	{ 1, (pvalue_t []) { CAP_SYS_CHROOT,		}, },
   [ZCAP_NICE] = 	{ 1, (pvalue_t []) { CAP_SYS_NICE 		}, },
@@ -123,6 +124,7 @@ static struct
 #else
   [ZCAP_NET_ADMIN] =	{ 1, (pvalue_t []) { PRIV_SYS_NET_CONFIG	}, },
 #endif
+  [ZCAP_DL_CONFIG] =	{ 1, (pvalue_t []) { PRIV_SYS_DL_CONFIG		}, },
   [ZCAP_NET_RAW] = 	{ 2, (pvalue_t []) { PRIV_NET_RAWACCESS,
                                              PRIV_NET_ICMPACCESS 	}, },
   [ZCAP_CHROOT] = 	{ 1, (pvalue_t []) { PRIV_PROC_CHROOT		}, },
@@ -137,6 +139,7 @@ static struct
                                              PRIV_FILE_DAC_READ		}, },
   [ZCAP_SYS_ADMIN] =	{ 1, (pvalue_t []) { PRIV_SYS_ADMIN		}, },
   [ZCAP_FOWNER] =	{ 1, (pvalue_t []) { PRIV_FILE_OWNER		}, },
+  [ZCAP_EXEC] =		{ 1, (pvalue_t []) { PRIV_PROC_EXEC		}, },
 #endif /* HAVE_SOLARIS_CAPABILITIES */
 };
 
diff --git lib/privs.h lib/privs.h
index 46d614e..13dbfaf 100644
--- lib/privs.h
+++ lib/privs.h
@@ -38,6 +38,8 @@ typedef enum
   ZCAP_DAC_OVERRIDE,
   ZCAP_READ_SEARCH,
   ZCAP_FOWNER,
+  ZCAP_DL_CONFIG,
+  ZCAP_EXEC,
   ZCAP_MAX
 } zebra_capabilities_t;
 
diff --git lib/sigevent.c lib/sigevent.c
index 30e9a3d..2aeb201 100644
--- lib/sigevent.c
+++ lib/sigevent.c
@@ -219,6 +219,7 @@ static void
 trap_default_signals(void)
 {
   static const int core_signals[] = {
+#ifndef NO_CORE_SIGNALS
     SIGQUIT,
     SIGILL,
 #ifdef SIGEMT
@@ -236,6 +237,7 @@ trap_default_signals(void)
 #ifdef SIGXFSZ
     SIGXFSZ,
 #endif
+#endif /* NO_CORE_SIGNALS */
   };
   static const int exit_signals[] = {
     SIGHUP,
diff --git solaris/Makefile.am solaris/Makefile.am
index acccbdb..3520bc5 100644
--- solaris/Makefile.am
+++ solaris/Makefile.am
@@ -14,7 +14,7 @@
 pkg_packages = $(pkg_names:%=@PACKAGE_TARNAME@-%-$(pkg_name_rev).pkg)
 pkg_pkginfos = $(pkg_names:%=pkginfo.%.full)
 pkg_prototypes = $(pkg_names:%=prototype.%)
-pkg_manifests = quagga.xml
+pkg_manifests = quagga.xml trill.xml
 
 # pkgmk variable substitutions wont grok ${variable} in prototype
 # file, so we cant let autoconf generate the file sadly
diff --git solaris/trill.xml.in solaris/trill.xml.in
new file mode 100644
index 0000000..f768878
--- /dev/null
+++ solaris/trill.xml.in
@@ -0,0 +1,94 @@
+<?xml version="1.0"?>
+<!DOCTYPE service_bundle SYSTEM "/usr/share/lib/xml/dtd/service_bundle.dtd.1">
+<!--
+	This file is part of Quagga.
+
+	Quagga is free software; you can redistribute it and/or modify it
+	under the terms of the GNU General Public License as published by the
+	Free Software Foundation; either version 2, or (at your option) any
+	later version.
+
+	Quagga is distributed in the hope that it will be useful, but 
+	WITHOUT ANY WARRANTY; without even the implied warranty of
+	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+	General Public License for more details.
+
+	You should have received a copy of the GNU General Public License  
+	along with Quagga; see the file COPYING.  If not, write to the Free
+	Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
+	02111-1307, USA.
+
+	Copyright (c) 2009, 2011, Oracle and/or its affiliates. All rights reserved.
+	Use is subject to license terms.
+-->
+
+<service_bundle type='manifest' name='SUNWtrill-daemons:quagga'>
+
+<service
+	name='network/routing/trill'
+	type='service'
+	version='1'>
+
+	<dependency name='filesystem'
+		grouping='require_all'
+		restart_on='none'
+		type='service'>
+		<service_fmri value='svc:/system/filesystem/local' />
+	</dependency>
+
+	<dependency name='datalink'
+		grouping='require_all'
+		restart_on='none'
+		type='service'>
+		<service_fmri value='svc:/network/datalink-management' />
+	</dependency>
+
+	<exec_method
+		type='method'
+		name='stop'
+		exec=':kill'
+		timeout_seconds='60'>
+	</exec_method>
+
+	<exec_method
+		type='method'
+		name='start'
+		exec='/usr/sbin/trilld -i "" -P 0 %i &amp;'
+		timeout_seconds='60'>
+		<method_context>
+		  <method_credential
+		   user='root' group='root' />
+ 		</method_context>
+	</exec_method>
+
+	<exec_method
+		type='method'
+		name='refresh'
+		exec=':kill -HUP'
+		timeout_seconds='60'>
+	</exec_method>
+
+	<property_group name='startd'
+		type='framework'>
+		<!-- sub-process core dumps shouldn't restart session -->
+		<propval name='ignore_error'
+		    type='astring' value='core,signal' />
+	</property_group>
+
+	<stability value='Unstable' />
+
+	<template>
+		<common_name>
+			<loctext xml:lang='C'>
+			Quagga: trilld, TRILL bridging protocol daemon.
+			</loctext>
+		</common_name>
+		<documentation>
+			<manpage title='trilld' section='1M'
+				manpath='/usr/share/man' />
+			<doc_link name='quagga.net' 
+				uri='http://www.quagga.net/' />
+		</documentation>
+	</template>
+</service>
+</service_bundle>
